<?php
/**
 */

namespace execut\images\bootstrap;


use execut\images\Attacher;
use execut\images\Module;
use execut\yii\Bootstrap;
use Imagine\Image\ImageInterface;

class Common extends Bootstrap
{
    public $_defaultDepends = [
        'modules' => [
            'images' => [
                'class' => Module::class,
            ],
        ],
    ];

    public function bootstrap($app)
    {
        parent::bootstrap($app); // TODO: Change the autogenerated stub

        $this->attachToModules();
    }

    protected function attachToModules() {
        $imagesModule = \yii::$app->getModule('images');
        $models = $imagesModule->getAttachedModels();
        $sizes = $imagesModule->getSizes();
        $tables = [];
        foreach ($models as $model) {
            $tables[] = $model::tableName();
        }

        $attacher = new Attacher([
            'tables' => $tables,
            'sizes' => $sizes,
        ]);

        $attacher->safeUp();
    }
}